/****************************************************************************/
/*  Copyright 2005, Trustees of Indiana University                          */
/*  Author: Sidharth Thakur                                                 */
/*  Last modified: 14 January 2006                                          */
/*  License available at: <belt-trick-* folder>/docs/downloads/License.txt  */
/****************************************************************************/
#ifndef _MATHOBJECT_
#define _MATHOBJECT_

#include "all.h"
#include "QuaternionSet.h"

class MathObject 
{
public:
	MathObject();
	~MathObject();
	
public:
	int				id;
	Vertex			*vrtList;
	Vertex			*pntList;
	QuaternionSet	*qset;

	//----------------------------------------------//
	/* admin options */
	void			initObject		( void );
	void			initStructs		( void );
	void			clearAll		( void );
	void			reset			( void );
	void			display			( void );
    void            renderAxes      ( void );
        
	//----------------------------------------------//


	//----------------------------------------------//
	/* display options */
	// > global
    int             showAxes;
	int				showCurve;						//
	int				showEdge;						//
    int             showEdgeOnly;
	int				showFrame;						//
	int				showFace;						//
	int				showMesh;						//
	int				showNormals;					//
	int				showControlPoints;				//
	int				showSphere;
	int				showTracker;
	
	// > quaternion map 
    int     		showQuatMap;					//
	int				qshowAxes;
	int				whichQuatComponent;				//
    int     		showViewXYZ;					//
    int     		showViewWYZ;					//
	int				showViewWXY;					//
	int				showViewWXZ;					//

	int				whichFrame;						//
	int				whichQuatFrame;					//
	int				whichSpline;					//
	double			startTheta;						//
	//----------------------------------------------//


	//----------------------------------------------//
	/* drawing options */
	double			fgcolor[3];
	double			bgcolor[3];
	//----------------------------------------------//

	//----------------------------------------------//
	/* BELT options */
	double			balpha;
    double          bsetupalpha;
    int             bmultiple;
	int				bhiderest;
	double			bwidth;
    int             bspheres;
    int             bspheresFactor;
	int				bspine;
    int				bpattern;
    int				btrackerpos;

	quaternion		*bquatlist;
	quaternion		*setupquatlist;
	quaternion		*bquatlist2;
	quaternion		*bquatlist3;
	Vertex			*bpntlist;
	Vertex			*tpntlist;						// Transformed point list
	Vertex			*npntlist;
	Vertex			*br,*bl;						// Right and Left belt points
	int				inp_chkbox_belt_spheres;		// Input check-box value for display
													// of belt-section spheres
	int				inp_chkbox_belt_type;			// Input check-box value for type
													// of deformation in belt-trick
	int				inp_chkbox_belt_show_numbers;	
	int				inp_chkbox_belt_spheres_wire;	//
	int				inp_slider_belt_angle;			// Input slider value for angle 
													// of belt deformation in belt-trick
    int				inp_slider_belt_setup_angle;	//        
	int				inp_slider_belt_width;			// Input slider value for width 
													// of belt in belt-trick
	void			showQuaternionMap	( void );	// Display quaternion map


	//# flags
	int				flag_blend;
	int				flag_track_belt;
	int				flag_do_not_compute;

	//----------------------------------------------//
};

#endif
